define([ "./deferred", "./testcontext", "./extransform", "require", "exports" ], function(e, t, n, i, a) {
    function o(e, t) {
        this._loggerStack = [], this._pendingActorsByLoggerType = {}, this._captureAllLoggersByType = {}, 
        this.envOptions = e || {}, this.caseBlackboard = {}, this.fileBlackboard = t, this.testDomainSeq = 0, 
        this._liveActors = null;
    }
    function r(e, t, n, i) {
        if (!e) throw new Error("No test definer provided!");
        this._testDefiner = e, this._exposeToTestOptions = n, this._fileBlackboard = {}, 
        this._resultsReporter = i, this._runtimeContext = null, this._superDebug = t, this._logBadThingsToLogger = null;
    }
    function s(e) {
        function t(e) {
            if (null != e && "object" == typeof e) {
                if (-1 !== n.indexOf(e)) return console.error("CYCLE with traversal", i), void 0;
                n.push(e), i.push(".");
                var a, o = i.length - 1;
                a = "toJSON" in e ? e.toJSON() : e;
                for (var r in a) if (a.hasOwnProperty(r)) {
                    var s = a[r];
                    i[o] = r, t(s);
                }
                n.pop(), i.pop();
            }
        }
        var n = [], i = [];
        t(e);
    }
    function c(e, i, a, o, r) {
        var s = {
            schema: t.LOGFAB._rawDefs,
            fileFailure: {
                fileName: e,
                moduleName: i,
                variant: a,
                exceptions: o.map(n.transformException)
            }
        };
        r(s);
    }
    function l(e) {
        return function(t) {
            e("##### LOGGEST-TEST-RUN-BEGIN #####");
            try {
                e(JSON.stringify(t));
            } catch (n) {
                console.error("JSON problem:", n.message, n.stack, n);
                try {
                    s(t.log);
                } catch (i) {
                    console.error("exx y", i);
                }
            }
            e("##### LOGGEST-TEST-RUN-END #####");
        };
    }
    var d = t.STEP_TIMEOUT_MS;
    o.prototype = {
        toString: function() {
            return "[TestRuntimeContext]";
        },
        toJSON: function() {
            return {
                type: "TestRuntimeContext"
            };
        },
        pushLogger: function(e) {
            this._loggerStack.push(e);
        },
        popLogger: function(e) {
            var t = this._loggerStack.lastIndexOf(e);
            -1 !== t && this._loggerStack.splice(t, 1);
        },
        reportPendingActor: function(e) {
            var t = e.__defName;
            this._pendingActorsByLoggerType.hasOwnProperty(t) ? this._pendingActorsByLoggerType[t].push(e) : this._pendingActorsByLoggerType[t] = [ e ];
        },
        captureAllLoggersByType: function(e, t) {
            t ? this._captureAllLoggersByType[e] = t : delete this._captureAllLoggersByType[e];
        },
        reportNewLogger: function(e, t) {
            var n = e.__defName;
            if (this._pendingActorsByLoggerType.hasOwnProperty(n) && this._pendingActorsByLoggerType[n].length) {
                var i = this._pendingActorsByLoggerType[n].shift();
                i.__attachToLogger(e);
            } else this._captureAllLoggersByType.hasOwnProperty(n) && "object" != typeof e._ident && (this._captureAllLoggersByType[n][e._ident] = e);
            return !t && this._loggerStack.length ? this._loggerStack[this._loggerStack.length - 1] : t;
        },
        reportActiveActorThisStep: function(e) {
            if (!e) throw new Error("You are passing in a null actor!");
            if (null === this._liveActors) throw new Error("We are not in a step!");
            e._activeForTestStep || (this._liveActors.push(e), e.__prepForTestStep(this));
        },
        peekLogger: function() {
            return this._loggerStack.length ? this._loggerStack[this._loggerStack.length - 1] : null;
        }
    }, a.TestDefinerRunner = r, r.prototype = {
        toString: function() {
            return "[TestDefinerRunner]";
        },
        toJSON: function() {
            return {
                type: "TestDefinerRunner"
            };
        },
        runTestStep: function(t) {
            function n() {
                for (var n = 0; n < r.length; n++) o = r[n], o._logger ? o.__failUnmetExpectations() : t.log.actorNeverGotLogger(o.__defName, o.__name), 
                o.__resetExpectations();
                f._runtimeContext._liveActors = null, e.getAllActiveDeferreds().forEach(function(e) {
                    t.log.unresolvedPromise(e);
                }), i && i(" :( timeout, fail"), t.log.timeout(), t.log.result("fail"), h.resolve(!1), 
                h = null;
            }
            const i = this._superDebug;
            i && i("====== Running Step: " + t.log._ident);
            var a, o;
            this._logBadThingsToLogger = t.log;
            var r = this._runtimeContext._liveActors = t.actors.concat();
            for (a = 0; a < t.actors.length; a++) o = t.actors[a], o.__prepForTestStep(this._runtimeContext);
            t.log.run_begin();
            var s = t.log.stepFunc(null, t.testFunc);
            if (s instanceof Error) return i && i(" :( encountered an error in the step func:", s), 
            t.log.run_end(), t.log.result("fail"), Promise.resolve(!1);
            i && i(" there are", r.length, "live actors this step", "up from", t.actors.length, "step-defined actors");
            var c = [], l = !0;
            for (a = 0; a < r.length; a++) {
                o = r[a];
                var p = o.__waitForExpectations();
                if (p.then) c.push(p), i && i(" actor", o.__defName, o.__name, "generated a promise"); else if (!p) {
                    if (i) {
                        var u;
                        u = o._expectNothing && (o._expectations.length || o._iExpectation) ? "expected nothing, got something" : o._expectationsMetSoFar ? "unsure" : "expectations not met after " + o._iExpectation, 
                        i(" :( waitVal synchronously resolved to false on " + o + " because: " + u);
                    }
                    l = !1;
                }
            }
            if (c.length) {
                var h = new e(), f = this, m = setTimeout(function() {
                    f._superDebug && f._superDebug("!! timeout fired, deferred?", null !== h), h && n();
                }, t.timeoutMS || d);
                return this._superDebug && this._superDebug("waiting on", c.length, "promises"), 
                Promise.all(c).then(function g() {
                    if (f._superDebug && f._superDebug("!! all resolved, deferred?", null !== h), h) {
                        clearTimeout(m);
                        for (var g = !0, e = 0; e < r.length; e++) o = r[e], o.__resetExpectations() || (g = !1, 
                        i && i(" :( weird actor error on: " + o));
                        f._runtimeContext._liveActors = null, t.log.run_end(), t.log.result(g ? "pass" : "fail"), 
                        h.resolve(l), h = null;
                    }
                }, function() {
                    f._superDebug && f._superDebug("!! failed, deferred?", null !== h), h && (clearTimeout(m), 
                    n());
                }), h.promise;
            }
            for (t.log.run_end(), t.log.result(l ? "pass" : "fail"), a = 0; a < r.length; a++) o = r[a], 
            o.__resetExpectations();
            return this._runtimeContext._liveActors = null, Promise.resolve(l);
        },
        skipTestStep: function(e) {
            return e.log.result("skip"), Promise.resolve(!0);
        },
        runTestCasePermutation: function(e) {
            var n = this;
            return new Promise(function(i, a) {
                function o(t) {
                    if (t || (c = !1), l >= r.__steps.length) return n._runtimeContext.popLogger(r._log), 
                    n._superDebug && n._superDebug("========= Done Case: " + e.desc + "\n"), r._log.result(c ? "pass" : "fail"), 
                    r._log.run_end(), e.log.result(c ? "pass" : "fail"), e.log.run_end(), i(c), void 0;
                    var a = r.__steps[l++], s = c || "cleanup" === a.kind;
                    s ? n.runTestStep(a).then(o) : n.skipTestStep(a).then(o);
                }
                n._superDebug && n._superDebug("========= Begin Case: " + e.desc + "\n"), e.log.run_begin();
                var r = new t.TestContext(e, 0);
                this._exposeToTestOptions && this._exposeToTestOptions.variant && (e.log.variant(this._exposeToTestOptions.variant), 
                r.setPermutationVariant(this._exposeToTestOptions.variant)), r._log.run_begin(), 
                n._runtimeContext.pushLogger(r._log);
                var s = r._log.setupFunc({}, e.setupFunc, r, n._runtimeContext);
                s instanceof Error && (n._superDebug && n._superDebug(" :( setup func error thrown! " + s), 
                r._log.result("fail"), e.log.result("fail"), a(!1)), r.__postSetupFunc();
                var c = !0, l = 0;
                o(!0);
            }.bind(this));
        },
        runTestCase: function(e) {
            return this._runtimeContext = new o(this._exposeToTestOptions, this._fileBlackboard), 
            this._markDefinerUnderTest(this._testDefiner), this.runTestCasePermutation(e, 0);
        },
        _markDefinerUnderTest: function(e) {
            e._runtimeContext = this._runtimeContext;
            for (var t = 0; t < e.__logfabs.length; t++) e.__logfabs[t]._underTest = this._runtimeContext;
        },
        _clearDefinerUnderTest: function(e) {
            e._runtimeContext = null;
            for (var t = 0; t < e.__logfabs.length; t++) e.__logfabs[t]._underTest = null;
        },
        runAll: function(t, n) {
            function i() {
                if (s >= c.__testCases.length) return t.removeListener("exit", a), t.removeListener("uncaughtException", o), 
                c._log.run_end(), l._clearDefinerUnderTest(c), e.clearActiveDeferreds(), r.resolve(l), 
                void 0;
                var n = c.__testCases[s++];
                l.runTestCase(n).then(i);
            }
            function a() {
                console.error("IMMINENT EVENT LOOP TERMINATION IMPLYING BAD TEST, DUMPING LOG."), 
                l.reportResults();
            }
            function o(e) {
                l._logBadThingsToLogger && l._logBadThingsToLogger.uncaughtException(e);
            }
            n && (d = n);
            var r = new e("TestDefinerRunner.runAll"), s = 0, c = this._testDefiner, l = this;
            return c._log.run_begin(), t.once("exit", a), t.on("uncaughtException", o), e.setUnhandledRejectionHandler(o), 
            i(), r.promise;
        },
        reportResults: function() {
            var e, n, i = this._testDefiner, a = {};
            n = t.LOGFAB._rawDefs;
            for (e in n) a[e] = n[e];
            n = t.__LAZYLOGFAB._rawDefs;
            for (e in n) a[e] = n[e];
            for (var o = 0; o < i.__logfabs.length; o++) {
                n = i.__logfabs[o]._rawDefs;
                for (e in n) a[e] = n[e];
            }
            var r = {
                schema: a,
                log: i._log
            };
            this._resultsReporter(r);
        }
    }, a.runTestsFromModule = function(t, n, a, o) {
        function s() {
            o && o('All tests in "' + t + '" run, ' + "generating results."), p.reportResults(), 
            u.resolve(!0);
        }
        var p, u = new e("runTestsFromModule:" + t), h = n.resultsReporter || l(a.reliableOutput), f = null;
        n && n.variant && (f = n.variant);
        var m = !1;
        return a.callbackOnError(function(e, n) {
            m || (c(t, n, f, [ e ], h), u.resolve(!0), m = !0);
        }), i([ t ], function(e) {
            var i = a.gobbleAndStopTrappingErrors();
            if (!m) {
                if (i.length) return c(t, "", f, i, h), u.resolve(!0), void 0;
                if (!e.TD) {
                    var l = new Error("Test module: '" + t + "' does not export a 'TD' symbol!");
                    return c(t, t, f, [ l ], h), u.resolve(!0), void 0;
                }
                n.hasOwnProperty("defaultStepDuration") && (d = n.defaultStepDuration), p = new r(e.TD, o, n.exposeToTest, h), 
                p.runAll(a).then(s, s);
            }
        }), u.promise;
    };
});